package envoy.client.ui;

import java.awt.Color;
import java.io.Serializable;

/**
 * 
 * Project: <strong>envoy-client</strong><br>
 * File: <strong>Theme.java</strong><br>
 * Created: <strong>23 Nov 2019</strong><br>
 * 
 * @author Maximilian K&auml;fer
 * @since Envoy v0.2-alpha
 */
public class Theme implements Serializable {

	private static final long serialVersionUID = 141727847527060352L;

	private String	themeName;
	private Color	backgroundColor;
	private Color	cellColor;
	private Color	interactableBackgroundColor;
	private Color	userNameColor;
	private Color	interactableForegroundColor;
	private Color	messageColorChat;
	private Color	dateColorChat;
	private Color	selectionColor;
	private Color	typingMessageColor;

	public Theme(String themeName, Color backgroundColor, Color cellColor, Color interactableForegroundColor,
			Color interactableBackgroundColor, Color messageColorChat, Color dateColorChat, Color selectionColor,
			Color typingMessageColor, Color userNameColor) {

		this.themeName = themeName;

		this.backgroundColor				= backgroundColor;
		this.cellColor						= cellColor;
		this.interactableForegroundColor	= interactableForegroundColor;
		this.interactableBackgroundColor	= interactableBackgroundColor;
		this.messageColorChat				= messageColorChat;
		this.dateColorChat					= dateColorChat;
		this.selectionColor					= selectionColor;
		this.typingMessageColor				= typingMessageColor;
		this.userNameColor					= userNameColor;
	}
	
	public Theme(String name, Theme other) {
		this(name, other.backgroundColor, other.cellColor, other.interactableBackgroundColor,
				other.interactableForegroundColor, other.messageColorChat, other.dateColorChat, other.selectionColor,
				other.typingMessageColor, other.userNameColor);
	}

	public String getThemeName() { return themeName; }

	public Color getInteractableForegroundColor() { return interactableForegroundColor; }

	public Color getMessageColorChat() { return messageColorChat; }

	public Color getDateColorChat() { return dateColorChat; }

	public Color getSelectionColor() { return selectionColor; }

	public Color getTypingMessageColor() { return typingMessageColor; }

	public Color getBackgroundColor() { return backgroundColor; }

	public Color getCellColor() { return cellColor; }

	public Color getInteractableBackgroundColor() { return interactableBackgroundColor; }

	public Color getUserNameColor() { return userNameColor; }

	public Color[] getAllColors() {
		Color[] c = new Color[9];
		c[0]	= backgroundColor;
		c[1]	= cellColor;
		c[2]	= interactableForegroundColor;
		c[3]	= interactableBackgroundColor;
		c[4]	= messageColorChat;
		c[5]	= dateColorChat;
		c[6]	= selectionColor;
		c[7]	= typingMessageColor;
		c[8]	= userNameColor;

		return c;
	}

	public void setColor(int index, Color newColor) {
		switch (index) {
			case 0:
				this.backgroundColor = newColor;
				break;
			case 1:
				this.cellColor = newColor;
				break;
			case 2:
				this.interactableForegroundColor = newColor;
				break;
			case 3:
				this.interactableBackgroundColor = newColor;
				break;
			case 4:
				this.messageColorChat = newColor;
				break;
			case 5:
				this.dateColorChat = newColor;
				break;
			case 6:
				this.selectionColor = newColor;
				break;
			case 7:
				this.typingMessageColor = newColor;
				break;
			case 8:
				this.userNameColor = newColor;
				break;

		}
	}

}
